import { EntityState } from './type';

export function getInitialEntityState<T, E>(): EntityState<T, E> {
  return {
    ids: [],
    entities: {},
    error: null,
  };
}

export function createInitialStateFactory<T, E>() {
  function getInitialState(): EntityState<T, E>;
  function getInitialState<S extends object>(additionalState: S): EntityState<T, E> & S;
  function getInitialState(additionalState: any = {}): any {
    return Object.assign(getInitialEntityState(), additionalState);
  }

  return {
    getInitialState
  };
}
