import {
  NgModule,
  ModuleWithProviders,
} from '@angular/core';

import {
  LoggerConfig,
} from './ng-logger.config';

import {
  LoggerService,
} from './ng-logger.service';

export interface LoggerFeatureModuleConfig {
  url?: any;
}

export interface LoggerRootModuleConfig {
  config: LoggerConfig;
}

const SERVICES = [
  LoggerService,
];

@NgModule({})
export class LoggerRootModule {
  constructor(
    private loggerService: LoggerService,
  ) {
  }
}

@NgModule({})
export class LoggerFeatureModule {
  constructor(
    private loggerService: LoggerService,
    private root: LoggerRootModule,
  ) {
  }
}

@NgModule({})
export class LoggerModule {
  static forRoot(config: LoggerRootModuleConfig): ModuleWithProviders {
    return {
      ngModule: LoggerRootModule,
      providers: [
        {
          provide: LoggerConfig,
          useValue: config.config,
        },
        SERVICES,
      ],
    };
  }

  static forFeature(config: LoggerFeatureModuleConfig): ModuleWithProviders {
    return {
      ngModule: LoggerFeatureModule,
      providers: [
      ],
    };
  }
}
