import {
  Type,
  PropertyKeyType,
} from '@loafer/core';

import {
  Annotation,
} from '@loafer/core/reflect';

import {
  Decorator,
} from '@loafer/decorator';

export class RPCSubscriberAnnotation extends Annotation {
  method: string;
}

export function RPCSubscriber(config: RPCSubscriberAnnotation): MethodDecorator {
  return function<T>(target: Object, propertyKey: PropertyKeyType, descriptor: TypedPropertyDescriptor<T>)
                                                                                : TypedPropertyDescriptor<T> | void {

    Decorator.register(RPCSubscriberAnnotation, config, target, propertyKey, descriptor);
  };
}
